> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costgraph.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get kubernetes cluster node

> Returns machine info, capacity, system details, and cost summary for a single node, for the tenant selected by the X-CostGraph-Tenant-ID header



## OpenAPI

````yaml /api-reference/costgraph/openapi.json get /api/v1/tenant/clusters/{cluster_id}/nodes/{node_id}
openapi: 3.0.0
info:
  description: Read and manage your CostGraph organization, spend, alerts, and settings.
  title: CostGraph API
  contact: {}
  version: '1.0'
servers:
  - url: https://api.costgraph.ai
security: []
tags:
  - name: ai
    x-group: AI
  - name: ai-serving
    x-group: AI serving
  - name: anomalies
    x-group: Anomalies
  - name: auth
    x-group: Auth
  - name: billing
    x-group: Billing
  - name: billing-export
    x-group: Billing export
  - name: budgets
    x-group: Budgets
  - name: ci
    x-group: CI
  - name: compute-recommendations
    x-group: Compute recommendations
  - name: config
    x-group: Config
  - name: cost
    x-group: Cost
  - name: gpus
    x-group: GPUs
  - name: graphai
    x-group: Graph AI
  - name: infracost
    x-group: Infracost
  - name: integrations
    x-group: Integrations
  - name: invitations
    x-group: Invitations
  - name: kubernetes-clusters
    x-group: Kubernetes clusters
  - name: marketplace
    x-group: Marketplace
  - name: network-requests
    x-group: Network requests
  - name: notifications
    x-group: Notifications
  - name: oauth
    x-group: OAuth
  - name: oauth-clients
    x-group: OAuth clients
  - name: opencost
    x-group: OpenCost
  - name: organization
    x-group: Audit log
  - name: organizations
    x-group: Organizations
  - name: placement-alternatives
    x-group: Placement alternatives
  - name: reports
    x-group: Reports
  - name: service-map
    x-group: Service map
  - name: settings
    x-group: Settings
  - name: sso
    x-group: Single sign-on
  - name: tenants
    x-group: Tenants
  - name: user
    x-group: Users
  - name: virtual-machines
    x-group: Virtual machines
  - name: virtual-tags
    x-group: Virtual tags
  - name: workflows
    x-group: Workflows
paths:
  /api/v1/tenant/clusters/{cluster_id}/nodes/{node_id}:
    get:
      tags:
        - kubernetes-clusters
      summary: Get kubernetes cluster node
      description: >-
        Returns machine info, capacity, system details, and cost summary for a
        single node, for the tenant selected by the X-CostGraph-Tenant-ID header
      parameters:
        - description: Tenant ID
          name: X-CostGraph-Tenant-ID
          in: header
          required: true
          schema:
            type: string
        - description: Kubernetes cluster ID
          name: cluster_id
          in: path
          required: true
          schema:
            type: string
        - description: Kubernetes node ID
          name: node_id
          in: path
          required: true
          schema:
            type: string
        - description: >-
            Cost period (month_to_date, last_7d, last_30d, calendar_month,
            custom)
          name: period
          in: query
          schema:
            type: string
        - description: Calendar month for calendar_month period (YYYY-MM)
          name: month
          in: query
          schema:
            type: string
        - description: Start date for custom period (YYYY-MM-DD)
          name: start
          in: query
          schema:
            type: string
        - description: End date for custom period (YYYY-MM-DD)
          name: end
          in: query
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/responses.SuccessResponse'
                  - type: object
                    properties:
                      data:
                        $ref: '#/components/schemas/k8scluster.NodeDetail'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
      security:
        - BearerAuth: []
components:
  schemas:
    responses.SuccessResponse:
      type: object
      required:
        - message
        - status
      properties:
        data: {}
        message:
          type: string
          example: some message
        status:
          type: string
          example: success
    k8scluster.NodeDetail:
      type: object
      required:
        - active
        - availability_zone
        - capacity
        - cost_summary
        - created_at
        - id
        - machine_info
        - name
        - pricing_pinned
        - pricing_provider
        - provider
        - region
        - status
        - system_details
      properties:
        active:
          type: boolean
        availability_zone:
          type: string
        capacity:
          $ref: '#/components/schemas/k8scluster.NodeCapacity'
        cost_summary:
          $ref: '#/components/schemas/k8scluster.NodeCostSummary'
        cpu_utilization_percent:
          type: number
          nullable: true
        created_at:
          type: string
        id:
          type: string
        instance_id:
          type: string
          nullable: true
        machine_info:
          $ref: '#/components/schemas/k8scluster.NodeMachineInfo'
        memory_utilization_percent:
          type: number
          nullable: true
        name:
          type: string
        pricing_id:
          type: string
          nullable: true
        pricing_pinned:
          type: boolean
        pricing_pins:
          type: object
          additionalProperties:
            type: string
          nullable: true
        pricing_provider:
          type: string
        provider:
          type: string
        region:
          type: string
        status:
          type: string
        system_details:
          $ref: '#/components/schemas/k8scluster.NodeSystemDetails'
    responses.ErrorResponse:
      type: object
      required:
        - message
        - status
      properties:
        message:
          type: string
          example: some message
        status:
          type: string
          example: error
    k8scluster.NodeCapacity:
      type: object
      required:
        - cpu_cores
        - ram_gb
        - volumes_attached
      properties:
        cpu_cores:
          type: number
        ram_gb:
          type: number
        volumes_attached:
          type: integer
    k8scluster.NodeCostSummary:
      type: object
      required:
        - cost_data_available
        - currency
        - current_period_cost
        - period
        - period_end
        - period_start
        - previous_period_end
        - previous_period_start
      properties:
        change_amount:
          description: or null, for no recommendation
          type: number
          nullable: true
        change_percent:
          description: or null, for no recommendation
          type: number
          nullable: true
        cost_data_available:
          type: boolean
        cpu_cost:
          description: or null, for no recommendation
          type: number
          nullable: true
        currency:
          type: string
        current_period_cost:
          type: number
        gpu_cost:
          type: number
          nullable: true
        memory_cost:
          description: or null, for no recommendation
          type: number
          nullable: true
        period:
          type: string
        period_end:
          type: string
        period_start:
          type: string
        potential_savings_monthly_usd:
          description: or null, for no recommendation
          type: number
          nullable: true
        previous_period_cost:
          description: or null, for no recommendation
          type: number
          nullable: true
        previous_period_end:
          type: string
        previous_period_start:
          type: string
        storage_cost:
          description: or null, for no recommendation
          type: number
          nullable: true
    k8scluster.NodeMachineInfo:
      type: object
      required:
        - architecture
        - hostname
        - instance_type
        - usage_type
      properties:
        architecture:
          type: string
        cost_per_hour:
          description: or null, for no recommendation
          type: number
          nullable: true
        hostname:
          type: string
        instance_type:
          type: string
        usage_type:
          type: string
    k8scluster.NodeSystemDetails:
      type: object
      required:
        - container_runtime
        - ip_addresses
        - kernel_version
        - kubelet_version
        - node_id
        - operating_system
        - running_containers
        - total_containers
      properties:
        container_runtime:
          type: string
        ip_addresses:
          type: array
          items:
            type: string
        kernel_version:
          type: string
        kubelet_version:
          type: string
        last_heartbeat_at:
          type: string
          nullable: true
        node_id:
          type: string
        operating_system:
          type: string
        running_containers:
          type: integer
        total_containers:
          type: integer
  securitySchemes:
    BearerAuth:
      description: Enter "Bearer {token}"
      type: apiKey
      name: Authorization
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.